*
*
************************************************************************
*
       Subroutine DEDX_SPAR
*      --------------------
* Calculation of dE/dx by SPAR (Armstrong, Chandler) routine
*
* This subroutine should be executed after 
*     subr INCREASE_DATA_ARRAY, where NMAX is calculated
*
* units for stopping power [MeV/cm], range [cm]
*
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       Character OUTSPAR*12, C5*5
       Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
*
       Common/SKY1/dEdx(MAXC1,10002),dEdxN1(MAXC1,10002),
     # Rp1(MAXC1,10002)
*
       Common/STARS1/ dSdX1(MAXC1,MAXC,10002), 
     # dEdXNuc1(MAXC1,MAXC,10002), 
     # dEdXNuc0Ed1(MAXC1,MAXC,10002), dEdXNucEdTm1(MAXC1,MAXC,10002), 
     # CST1(MAXC1,MAXC,10002), NMAX
       Common/ISTOP/ISTOP
       Common/VENUS/RI(MAXC)
       Dimension TmpE(10002),dxdE(10002)
*
       if(istop.ne.1) return
* 
*
* Condensed matter supposed
      If(RO.le.0.01)  goto 91000
*
* Mean <I> for compound (only for printing)
           RIL=0.d0
           Do i=1,NK
           RIL= RIL+FR(i)*ZT(i)*dlog( RI(i) )
           Enddo
           RIL=2.718281828**(RIL/Z2)
*
      jj=2 ! condensed element
          if(NK.ne.1) then
* check if all components are isotopes of the same element
          IZT0=idint( ZT(1)+0.001)
          do i=1,NK
          IZT=idint( ZT(i)+0.001)
          if(IZT.ne.IZT0) then
                          jj=4   ! condensed compound
                          goto 1
                          endif
          IZT0=IZT
          enddo
                      endif
    1     continue
*
*
      NK1=NK+1
*
*
*
      Do  IK=1,NK1   
*     ------------
* IK - id of the moving ion,   IK=1: primary particle
*
*
* Projectile
      if(IK.eq.1) then
                     ZPR=Z1
                     APR=A1
                  else
                     ZPR=ZT(IK-1)
                     APR=AT(IK-1)
                  endif
*
        IZA=1000*idint(ZPR+0.001)+idint(APR+0.001)
        Write(C5,'(i5)')IZA
        outspar=C5//'.sto'
        open(21,file=outspar)

        Write(21,90001)ZPR,APR,IK,Z2,A2,JJ,RO,RN0,RIL*1.e+6
        Write(21,90002)
        Write(21,90003)
*
*
        Do I=1,999999999
*
* J=(lg(E)+6)*1000+1  means that energy can changes from 10**-6 MeV
* If 10002 array dimension will be increased change also 1000 below
* and in other subroutines (i.e. MODEL)
        RLG=dfloat(I-1)/1000. -6.
        E=10.**RLG   ! Energy (MeV)
! NMAX is already defined in subr INCREASE_DATA_ARRAY and check < 5 GeV is done 
       If(I.gt.NMAX) goto 7000
! Attention. NMAX is the same for all material components, it is
* supposed that SL_NLS code which is executed before IOTA code 
* was stopped at the same energy for all components
*
         Call SPAR0(ZPR, APR, E, dEdxTOTS, dEdxNS, JJ)
*
* total stopping power
          dEdx(IK,i)  =dEdxTOTS
* nuclear stopping
          dEdxN1(IK,i)=dEdxNS
* 
* calculate total path from 1/ dE/dx integration (lin-lin)
            TmpE(i)=E
                                dxdE(i)=0.0
            if(dEdxTOTS.ne.0.0) dxdE(i)=1./dEdxTOTS
       if(i.eq.1) then 
                  Rp1(IK,i)   =0.0
                  else
       Rp1(IK,i)=Rp1(IK,i-1)+(TmpE(i)-TmpE(i-1))*
     #           (dxdE(i)+dxdE(i-1))/2.
                 endif
*
*
        Enddo    !  Do I1=1,999999999
 7000   continue
*
* write results 
* units for printing MeV/mg/cm2, cm
                   prc=1./(1000.*RO)
c MeV/cm (?)
c                  prc=1.
        Do i=1,NMAX
        Write(21,90004) TmpE(i), prc*(dEdx(IK,i)-dEdxN1(IK,i)) ,
     #                            prc*dEdxN1(IK,i), Rp1(IK,i)
        Enddo
        close(21)
*
*
        Enddo    !  Do IK=1,NK1
*       -----------------------
*
*
               iiii=1
c        if(iiii.eq.1) stop
        Return
c
c
90001   Format(' Stopping power from SPAR (Armstrong, Chandler)'/
     #  ' projectile ',f6.1,f8.2,'       IK =',i3,
     #  /' medium     ',f6.1,f8.2,'    condensed   JJ =',i2,
     #  /' density =',f8.3,' g/cm3     n0 =',1pe12.5,' cm-3'
     #  /' mean ioniz pot = ',0pf8.2,' eV')
90002   Format(/' units  E [MeV],  dE/dx [MeV/mg/cm2],  R [cm] ')
90003   Format(/'     E        dE/dx(electr)  dE/dx(nucl)',
     #  '       R (total) '/ 61('-'))
90004   Format(1pe12.5,2e14.5,e17.5)
c
91000   Print 91001
91001   Format(/' Gaseous target is not allowed ! '
     #  /20x,'Change subr DEDXSPAR  !!')
        print *,'                        press any key...'
        pause
        stop
c
        End
