*
******************************************************************
*
         Subroutine FT12CHOICE(idsdt)
*        --------------------------
* Main formula
* f(x)=Lambda* x**(1-2m) [1+ {2*Lambda*x**(2*(1-m)}**q ]**(-1/q)
*
* Parameters are taken mainly from   W.Eckstein, "Computer Simulation
* of Ion-Solid Interactions"  Springer, Berlin, 1991, p.59, Table 4.8
*
*
* alp1 = L,  bet1 = (1-2*m),  alp2 = 2*L
* bet2 = 2*(1-m), bet3= q,    bet4 = -1/q
*
         implicit real*8(A-H,O-Z)
         Common/JUPITER/ALP1,ALP2,BET1,BET2,BET3,BET4
         Common/AUX1/rlambda,rm,q
*
         if(idsdt.eq.1) return   ! --> Burenkov et al function
         if(idsdt.eq.0) goto 10   
         goto(888,888,888,888,888,888,888,888,888,10,
     #        11,12,13,14,15), idsdt
         goto 888
*
* Original Winterbon et al parameters
10       rlambda=1.309
         rm=1./3.
         q=2./3.
         goto 777
*
* Thomas-Fermi-Sommerfeld
11       rlambda=1.7
         rm=0.311
         q=0.588
         goto 777
*
* Bohr
12       rlambda=2.37
         rm=0.103
         q=0.570
         goto 777
* 
* Lenz-Jensen
13       rlambda=2.92
         rm=0.191
         q=0.512
         goto 777
* 
* Moliere
14       rlambda=3.07
         rm=0.216
         q=0.530
         goto 777
*
* U.Littmark, J.F.Ziegler, "Handbook of Range Distributions"
* Kr-C potential
15       rlambda=3.35
         rm=0.2328
         q=0.4445
*
*
777      alp1=rlambda
         bet1=1.-2.*rm
         alp2=2.*rlambda
         bet2=2.*(1.-rm)
         bet3=q
         bet4=-1./q
!
         idsdt=0
         Return 
*
  888    Print 999,idsdt
  999    Format(' ERROR:    Parameters of f(t^1/2) are not known !'/
     #   '           idsdt=',i5,' is not correct.')      
         Print *,'                     press any key...'
         pause
         stop
         End
