*
************************************************************************
*
       Subroutine INCREASE_DATA_ARRAY
*      ------------------------------
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
*
       Common/dEdxMain01/Ex01(MAXC1,1501), dEdx01(MAXC1,1501),
     # Rp01(MAXC1,1501), dEdxN01(MAXC1,1501),NdE01(MAXC1)
*
       Common/Lindhard01/Energy01(MAXC1,MAXC,1701),  
     # dSdX01(MAXC1,MAXC,1701), dEdX_Nuc01(MAXC1,MAXC,1701), 
     # dEdX_Nuc_0Ed01(MAXC1,MAXC,1701), 
     # dEdX_Nuc_Ed_Tmax01(MAXC1,MAXC,1701),  
     # CST01(MAXC1,MAXC,1701), NSL01(MAXC1,MAXC)
*
* corresponds to /dEdxMain01/
       Common/SKY1/dEdx(MAXC1,10002),dEdxN1(MAXC1,10002),
     # Rp1(MAXC1,10002)
* corresponds to /Lindhard01/
       Common/STARS1/ dSdX1(MAXC1,MAXC,10002), 
     # dEdXNuc1(MAXC1,MAXC,10002), 
     # dEdXNuc0Ed1(MAXC1,MAXC,10002), dEdXNucEdTm1(MAXC1,MAXC,10002), 
     # CST1(MAXC1,MAXC,10002), NMAX
*
       Common/istop/istop
       Dimension TMP1(1701),TMP2(1701),TMP3(1701),TMP4(1701),
     #           TMP5(1701),TMP6(1701)
*
* =1 test printing, 0 no  
       itestxs=0 
*
       If(itestxs.ne.0) open(21,file='test.xs')
       If(itestxs.ne.0) Write(21,1000)
1000   Format('   I       E        dSdX      dEdX_Nuc',
     # '    dEdX_Nuc     dEdX_Nuc      CST'/
     # '                               (tot)      [0-Ed]',
     # '       [Ed-Tmax]    (barn)'/77('-'))
*
*
      NK1=NK+1
*
*
* General arrays preparation
*****************************
*
*
                               if(istop.ne.-1) goto 3001
* Ziegler data
* ============
*
      Do 2000 IK=1,NK1   
*     -------------
* IK - id of the moving ion
*
        NdE01tmp=NdE01(IK)
        Do II=1, NdE01tmp
        TMP1(II)=Ex01(IK,II)
        TMP2(II)=dEdx01(IK,II)
        TMP3(II)=dEdxN01(IK,II)
        TMP4(II)=Rp01(IK,II)
        Enddo
*
        Emaxtmp=dmin1(5000.,TMP1( NdE01tmp) )
        Do I=1,999999999
*
* J=(lg(E)+6)*1000+1  means that energy can changes from 10**-6 MeV
* If 10002 array dimension will be increased change also 1000 below
* and in other subroutines (i.e. MODEL, DEDX_SPAR)
        RLG=dfloat(I-1)/1000. -6.
        E=10.**RLG
* E > 5000 MeV is not considered
        If(E.gt.Emaxtmp) goto 2000
! Attention. NMAX is the same for all material components, it is
* supposed that SL_LNS code which is executed before IOTA code 
* was stopped at the same energy for all components
        NMAX=I
        If(NMAX.gt.10002) Call error0('NMAX',10002)
        Call ARRAYINT(0,TMP1,TMP2, NdE01tmp,E,2, RES1)
        Call ARRAYINT(0,TMP1,TMP3, NdE01tmp,E,2, RES2)
        Call ARRAYINT(0,TMP1,TMP4, NdE01tmp,E,2, RES3)
          dEdx(IK,NMAX)  =RES1
          dEdxN1(IK,NMAX)=RES2
          Rp1(IK,NMAX)   =RES3
        Enddo    !  Do I1=1,999999999
 2000   Continue !  Do IK=1,NK1
*
*
*
* Cross-sections obtained by Lindhard approach
* ============================================
*
 3001                          continue
*
      Do 3 IK=1,NK1   
*     -------------
*
* IK - id of the moving ion
* MK - id of the material component
*
      Do 2 MK=1,NK
*     ------------
*
      If(itestxs.ne.0) Write(21,11) IK,MK
11    Format('Interaction (ion id)  ',i2,' +',i3)
*
        NSL01tmp=NSL01(IK,MK)
        Do II=1, NSL01tmp
        TMP1(II)=Energy01(IK,MK,II)
        TMP2(II)=dSdX01(IK,MK,II)
        TMP3(II)=dEdX_Nuc01(IK,MK,II)
        TMP4(II)=dEdX_Nuc_0Ed01(IK,MK,II)
        TMP5(II)=dEdX_Nuc_Ed_Tmax01(IK,MK,II)
        TMP6(II)=CST01(IK,MK,II)
        Enddo
*
      Emaxtmp=dmin1(5000.,TMP1( NSL01tmp) )
      Do I=1,999999999
*
* J=(lg(E)+6)*1000+1  means that energy can changes from 10**-6 MeV
* If 10002 array dimension will be increased change also 1000 below
* and in other subroutines ( MODEL, DEDX_SPAR, ...)
        RLG=dfloat(I-1)/1000. -6.
        E=10.**RLG
* E > 5000 MeV is not considered
        If(E.gt.Emaxtmp) goto 2
        NMAX=I
        If(NMAX.gt.10002) Call error0('NMAX',10002)
*
*        
        Call ARRAYINT(0,TMP1,TMP2, NSL01tmp,E,2, RES1)
        Call ARRAYINT(0,TMP1,TMP3, NSL01tmp,E,2, RES2)
        Call ARRAYINT(0,TMP1,TMP4, NSL01tmp,E,2, RES3)
        Call ARRAYINT(0,TMP1,TMP5, NSL01tmp,E,2, RES4)
        Call ARRAYINT(0,TMP1,TMP6, NSL01tmp,E,2, RES5)
       If(itestxs.ne.0) Write(21,1)I,E,RES1,RES2,RES3,RES4,RES5
1      Format(i5,g12.5,5g12.5)
          dSdX1(IK,MK,NMAX)        =RES1  
          dEdXNuc1(IK,MK,NMAX)     =RES2
          dEdXNuc0Ed1(IK,MK,NMAX)  =RES3
          dEdXNucEdTm1(IK,MK,NMAX) =RES4
* barn ---> cm2
          CST1(IK,MK,NMAX)         =RES5*1.e-24
       EndDo
*
*
   2   Continue
   3   Continue
*
        If(itestxs.ne.0) close(21)
        Return
        End
