*
* IOTA-2017
*
*
**************************************************************************
*
* IOTA code
* ---------
*
*
* Maximal number of the material component is 21. To increase this 
* value change parameter(maxc= to N desirable value in all routines
* and maxc1= to N+1
*
* Maximal energy = 5 GeV
*  
*
c
c 
c Watcom random number generator is used now. To use other one
c change function RANDOMG
c
*
* Last changes 05/04/2007
*
c
       PROGRAM IOTA 2017
       parameter (maxe=50001)
       implicit real*8(A-H,O-Z)
       Character Cinp*500
       Common/EIN/EIN(MAXE),NH(MAXE),KEIN
       COMMON/RECSTORE/ATOM(50003,9),NKO(50003),INDIC(50003),
     !                 KGEN(50003),NREC
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
c          
       Cinp=' ';call getarg(1,Cinp); if(Cinp==' ') Cinp='input'
        
c======================================================================
c
c
c
*
* read input data file
         CALL READ_INPUT(Cinp)
*
* prepare basic data for calculations
         CALL PRECALCULATION
*
*
         Call SL_LNS50
*
* read cross-sections and dE/dx
         CALL READ_DATA
*
* make interpolation between data points
         CALL INCREASE_DATA_ARRAY
*
* calculate dE/dx by SPAR routine
         CALL DEDX_SPAR
*
*
c
c========================================================================
c
* Cycle for energies
* ------------------
        Do IE=1,KEIN
        T00=EIN(IE)
        NHIST=NH(IE)
c
            If(T00.gt.5000.) then
            Print *,' T0 exceeds the allowable maximum. Change the code'
            Call error0('    ',5000)
            Endif
        Call WRITE99A(T00,IE,NHIST)
*
*
        Call INITIALIZE_AND_ZEROIZE(T00)
*       
* Cycle for events
* ----------------
        Do 7 IH=1,Nhist         
cccc
cccc For all display types
cccc        Print 1000,IH,T00
cccc 1000   Format('*************  history =',I10,'     E=',g12.5)
cccc
         write(*,'(a1, a,1pg12.5,a, 0pi8,$)') char(13),'  Energy ',T00,
     c   ' MeV      events', iH
 
*
        Call DISPERS(1)
* 
* Primary ion movement
*                    IDE corresponds to the energy of the primary
*                        particle which attenuates in material
        Call FIRST_ION
     $            (IK,IE,T00,T0,P0,P0X,P0Y,P0Z,X0,Y0,Z0,IDE,IGEN,IDION)
*
        Call MODEL(IK,T0,P0,P0X,P0Y,P0Z,X0,Y0,Z0,IDE,IGEN,IDION) 
        if(NREC.le.0) goto 6
* 
* Secondary recoils movement
   2    Call STORE_OUT(MK,T1,P1,P1X,P1Y,P1Z,X1,Y1,Z1,IDE,IGEN1,IDION1)
*
cc                                         if(nrec.lt.0.and.md.eq.0) then
cc                                         print *,'strange error'
cc                                         stop
cc                                         endif
        if(NREC.lt.0) goto 6
        IK=MK+1
        Call MODEL(IK,T1,P1,P1X,P1Y,P1Z,X1,Y1,Z1,IDE,IGEN1,IDION1) 
        if(NREC.le.0) goto 6
        goto 2
*
*
*
   6    Call DISPERS(2)
        Write(99,1001)Nhist-IH
   7    Continue  
        Write(*,*)
*
* Integration of nu(T)dS/dT along the trajectory
        Call  LindInt(T00) 
ccccc   Print *,'*****  Finished !'
*
        Call Print(T00,Nhist)
c            
        Enddo !   Do IE=1,KEIN
*
        Call end_of_calculation
                                                              close(333)
        Stop                  
 1001   Format('end of history, remained:',i7) 
        End
